## python-bcj 1.0.2+ds

=== debian/changelog ===
python-bcj (1.0.2+ds-2) unstable; urgency=medium

  * Packaging update
  * Add README.rst file as upstream document.
  * patch: Avoid to use "sparc" keyword
    (debian/patches/0001-Avoid-to-use-sparc-keyword.patch)
    "sparc" is already defined as "1" in SPARC64 gcc (cpp).
    Use other keyword "sparc_arch" to avoid the error.
  * Standards-Version: 4.7.0 (routine-update)
  * Testsuite: autopkgtest-pkg-pybuild
  * Upgrade to new Python build sequencer
  * Do unit test from pybuild sequencer

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Apr 2024 11:43:22 +0900

python-bcj (1.0.2+ds-1) unstable; urgency=medium

  * Initial commit (Closes: #1068309)

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Fri, 05 Apr 2024 08:54:49 +0900

## python-bcj 1.0.3%2Bds

=== debian/watch ===
version=4
opts="uversionmangle=s/(rc|a|b|c)/~$1/, \
      dversionmangle=s/\+ds//, \
      oversionmangle=s/$/+ds/" \
https://pypi.debian.net/pybcj/pybcj-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## python-bcj 1.0.3+ds

=== debian/changelog ===
python-bcj (1.0.3+ds-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 23:13:53 +0000

python-bcj (1.0.3+ds-1) unstable; urgency=medium

  * New upstream version 1.0.3+ds

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sat, 28 Dec 2024 02:22:04 +0900

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=bcj

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=pybuild

## python-bcj 1.0.6+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)
project(pybcj C CXX)

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

# TARGET PYTHON version
set(PY_VERSION 3.12)
set(Python_FIND_IMPLEMENTATIONS CPython)
set(VENV_PATH "${CMAKE_BINARY_DIR}/venv")
set(DEBUG_BUILD ON)

# ##################################################################################################
# Configuration for python-ext
set(Python_FIND_STRATEGY VERSION)
find_package(Python ${PY_VERSION}.0...${PY_VERSION}.99 COMPONENTS Interpreter Development)
set(PY_EXT_FILE _bcj)
set(PY_EXT_DIR src/bcj)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/get_ext.py
     "import sysconfig\nprint(sysconfig.get_config_var('EXT_SUFFIX'))\n")
execute_process(
  COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/get_ext.py
  OUTPUT_VARIABLE PY_EXT_EXT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
set(PY_EXT ${PY_EXT_DIR}/${PY_EXT_FILE}.${PY_EXT_EXT})
set(PY_CFFI ${PY_CFFI_DIR}/PY_CFFI_FILE}.${PY_EXT_EXT})
# bulid ext by setup.py
if (WIN32)
  if(DEBUG_BUILD)
    set(BUILD_EXT_PYTHON ${VENV_PATH}/Scripts/python_d.exe)
  else()
    set(BUILD_EXT_PYTHON ${VENV_PATH}/Scripts/python.exe)
  endif()
  set(BUILD_EXT_OPTION)
else()
  set(BUILD_EXT_PYTHON ${VENV_PATH}/bin/python)
  set(BUILD_EXT_OPTION --warning-as-error)
endif()
set(pybcj_sources src/ext/Bra.c src/ext/Bra86.c src/ext/BraIA64.c)
set(pybcj_ext_src src/ext/_bcjmodule.c)
add_custom_target(
  generate_ext
  BYPRODUCTS ${PY_EXT}
  COMMAND ${BUILD_EXT_PYTHON} setup.py build_ext ${BUILD_EXT_OPTION} --inplace
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS venv.stamp
  SOURCES ${pybcj_sources} ${pybcj_ext_src})
add_library(_pybcj_ext MODULE ${pybcj_sources} ${pybcj_ext_src})
target_include_directories(_pybcj_ext PRIVATE ${Python_INCLUDE_DIRS} src/ext)
target_link_libraries(_pybcj_ext PRIVATE ${Python_LIBRARIES})
# ##################################################################################################
# create virtualenv
file(
        WRITE ${CMAKE_CURRENT_BINARY_DIR}/requirements.txt
        "
hypothesis
pytest>=6.0
")
if (WIN32)
  set(PIP_COMMAND ${VENV_PATH}/Scripts/pip.exe)
else()
  set(PIP_COMMAND ${VENV_PATH}/bin/pip)
endif()
add_custom_target(
        venv.stamp
        BYPRODUCTS venv.stamp
        COMMAND ${Python_EXECUTABLE} -m venv ${VENV_PATH}
        COMMAND ${PIP_COMMAND} install -r ${CMAKE_BINARY_DIR}/requirements.txt
        COMMAND ${CMAKE_COMMAND} -E touch venv.stamp)
set(SRC_PATH "${CMAKE_SOURCE_DIR}/src")
set(VPKG_PATH_A "${VENV_PATH}/lib/python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")
set(VPKG_PATH_B "${VENV_PATH}/Lib/site-packages/")
set(VPKG_PATH_C "${CMAKE_BINARY_DIR}")

# ##################################################################################################
# For pytest
file(
        WRITE ${CMAKE_CURRENT_BINARY_DIR}/pytest_runner.cpp
        "
#include <string>
#include <filesystem>
#include <unistd.h>
int main(int argc, char **argv) {
    std::string args;
    if ( argc > 1) {
        args.append(\"[\");
        for (int i = 1; i < argc; i++) {
            if (i > 2)
                args.append(\",\");
            args.append(\"\\\"\");
            args.append(argv[i]);
            args.append(\"\\\"\");
        }
        args.append(\"]\");
    }
    std::filesystem::path src_path = \"${SRC_PATH}\";
    std::filesystem::path vsite_path_a = \"${VPKG_PATH_A}\";
    std::filesystem::path vsite_path_b = \"${VPKG_PATH_B}\";
    std::filesystem::path vsite_path_c = \"${VPKG_PATH_C}\";
    std::string pycode =
        \"import sys\\n\"
        \"sys.path.append('\" + src_path.string() + \"')\\n\"
        \"sys.path.append('\" + vsite_path_a.string() + \"')\\n\"
        \"sys.path.append('\" + vsite_path_b.string() + \"')\\n\"
        \"import pytest\\n\"
        \"pytest.main(\" + args + \")\\n\";
    execl(\"${Python_EXECUTABLE}\", \"${Python_EXECUTABLE}\", \"-c\", pycode.c_str(), (char*)0);
    return 0;
}")
add_executable(pytest_runner ${CMAKE_CURRENT_BINARY_DIR}/pytest_runner.cpp)
target_include_directories(pytest_runner PRIVATE ${Python_INCLUDE_DIRS})
target_link_libraries(pytest_runner PRIVATE ${Python_LIBRARIES})
add_dependencies(pytest_runner venv.stamp generate_ext)

=== debian/changelog ===
python-bcj (1.0.6+ds-3) unstable; urgency=medium

  * Drop Emacs mode line from debian/watch

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Tue, 30 Sep 2025 11:52:58 +0900

python-bcj (1.0.6+ds-2) unstable; urgency=medium

  * Use V5 format for watch file
  * Use local configuration file for salsa CI

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 24 Aug 2025 00:48:43 +0900

python-bcj (1.0.6+ds-1) unstable; urgency=medium

  [ YOKOTA Hiroshi ]
  * Upgrade Debian Policy to 4.7.2
  * New upstream version 1.0.6+ds
  * Patches: remove 0001, merged upstream.

  [ Jeroen Ploemen ]
  * Copyright: bump years.

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Wed, 07 May 2025 02:47:44 +0900

=== debian/control ===
Source: python-bcj
Section: python
Testsuite: autopkgtest-pkg-pybuild
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-all,
  python3-all-dev,
  python3-pytest <!nocheck>,
  python3-hypothesis <!nocheck>,
  python3-setuptools,
  python3-setuptools-scm,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://codeberg.org/miurahr/pybcj
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-bcj
Vcs-Git: https://salsa.debian.org/python-team/packages/python-bcj.git

Package: python3-bcj
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: BCJ (Branch-Call-Jump) filter for Python
 In data compression, BCJ, short for Branch-Call-Jump, refers to a
 technique that improves the compression of machine code of executable
 binaries by replacing relative branch addresses with absolute ones.
 This allows a LZMA compressor to identify duplicate targets and
 archive higher compression rate.
 .
 BCJ is used in 7-zip compression utility as default filter for
 executable binaries.
 .
 pybcj is a Python bindings with BCJ implementation by C language. The
 C codes are derived from p7zip, portable 7-zip implementation. pybcj
 support Intel/Amd x86/x86_64, Arm/Arm64, ArmThumb, Sparc, PPC, and
 IA64.

=== debian/watch ===
Version: 5

Source: https://pypi.debian.net/pybcj/
Matching-Pattern: pybcj-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
Uversion-Mangle: s/(rc|a|b|c)/~$1/
Dversion-Mangle: s/\+ds//
Oversion-Mangle: s/$/+ds/

## python-bcj 1.0.7+ds

=== debian/changelog ===
python-bcj (1.0.7+ds-2) unstable; urgency=medium

  * Upgrade Debian standards to 4.7.3

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Sun, 28 Dec 2025 10:10:29 +0900

python-bcj (1.0.7+ds-1) unstable; urgency=medium

  * Lintian fix: redundant-rules-requires-root-no-field
  * New upstream version 1.0.7+ds
  * Restore test file from upstream

 -- YOKOTA Hiroshi <yokota.hgml@gmail.com>  Mon, 01 Dec 2025 01:14:25 +0900

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: python-bcj
 Section: python
 Testsuite: autopkgtest-pkg-pybuild
-Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: YOKOTA Hiroshi <yokota.hgml@gmail.com>
 Build-Depends:
@@ -14,8 +13,7 @@
   python3-hypothesis <!nocheck>,
   python3-setuptools,
   python3-setuptools-scm,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://codeberg.org/miurahr/pybcj
 Vcs-Browser: https://salsa.debian.org/python-team/packages/python-bcj
 Vcs-Git: https://salsa.debian.org/python-team/packages/python-bcj.git
